#ifndef _USBITLIB_H__
#include <USBitLib.h>
#endif


// USBit Library N`
//  KvɉăRgAEgAvWFNgł̃NwyсA\[XŃNĂB
#pragma comment(lib,"USBitLib")

// USBitAPIgp₷邽߂C++NX`
// P`lł邱ƂƁA`lɂĂ͕ʂɎKvLB
// ̃foCXڑĂꍇ́AfoCXƂĔFn߂
// foCXɑ΂ďуANeBuB
class USBitChargeDev {
public:
	USBIT_STATUS	status;
	HANDLE			hUSBit;
	USBIT_INFO		sInfo;
	USBIT_KIND		cKind;
	WORD			wIO;
public:	// Move Control
	USBIT_STATUS	MoveForward	(void){return SetCommand(USBIT_CMD_FORWARD);};
	USBIT_STATUS	MoveBack	(void){return SetCommand(USBIT_CMD_BACKWARD);};
	USBIT_STATUS	MoveLeft	(void){return SetCommand(USBIT_CMD_LEFT);};
	USBIT_STATUS	MoveRight	(void){return SetCommand(USBIT_CMD_RIGHT);};
	USBIT_STATUS	MoveLF		(void){return SetCommand(USBIT_CMD_FORLEFT);};
	USBIT_STATUS	MoveRF		(void){return SetCommand(USBIT_CMD_FORRIGHT);};
	USBIT_STATUS	MoveLB		(void){return SetCommand(USBIT_CMD_BACKLEFT);};
	USBIT_STATUS	MoveRB		(void){return SetCommand(USBIT_CMD_BACKRIGHT);};
	USBIT_STATUS	MoveWait	(void){return SetCommand(USBIT_CMD_WAIT);};
	USBIT_STATUS	MoveStop	(void){return SetCommand(USBIT_CMD_STOP);};
public: // Control Commands
	USBIT_STATUS SetCommand( USBIT_COMMAND nCommand, DWORD dwParam =0){	return status = USBit_SetCommand( hUSBit, nCommand, dwParam );};
	USBIT_STATUS SetComboCommand( USBIT_COMMAND nCommand1, BYTE bCmd1Num, USBIT_COMMAND nCommand2, BYTE bCmd2Num, DWORD dwParam=0 ){
		return status = USBit_SetComboCommand( hUSBit, nCommand1, bCmd1Num, nCommand2, bCmd2Num, dwParam=0 );
	};
public: // Setting Commands
	USBIT_STATUS	ChangeKind( USBIT_KIND cNewKind = USBIT_KIND_BITCHARG ){return status = ::USBit_ChangeKind(hUSBit,cNewKind);};
	USBIT_STATUS	SetBitChargNormal	(void){return ChangeKind(USBIT_KIND_BITCHARG);}
	USBIT_STATUS	SetBitChargBoost	(void){return ChangeKind(USBIT_KIND_BITCHARG_BOOST);}
	USBIT_STATUS	GetInfo( PUSBIT_INFO pInfo=NULL ){
		ZeroMemory(&sInfo,sizeof(USBIT_INFO)); if(pInfo!=NULL) ZeroMemory(pInfo,sizeof(USBIT_INFO));
		if(hUSBit==NULL) return USBIT_STS_NOTINIT;
		sInfo.dwSize=sizeof(USBIT_INFO);
		if((status= ::USBit_GetInfo( hUSBit, &sInfo ))==USBIT_STS_NOERROR){if(pInfo!=NULL)*pInfo=sInfo;}
		return status;
	};
public: // device status
	WORD GetFreq(void){return (WORD)sInfo.bFrequency;};
public: // Lowlevel I/O Control Commands
	WORD ReadIoPort(BYTE bIndex, LPBYTE pbData ,BYTE bDataNum){
		if(hUSBit==NULL) return (WORD)-1; return wIO = USBit_ReadIoPort( hUSBit, bIndex, pbData ,bDataNum);
	};
	WORD WriteIoPort(BYTE bPort, BYTE bEnable, BYTE bMask, BYTE bData ){
		if(hUSBit==NULL) return (WORD)-1; return wIO = USBit_WriteIoPort( hUSBit, bPort, bEnable, bMask, bData );
	};
public: // Initialyzation
	HANDLE			GetHandle(void){return hUSBit;};
	USBIT_STATUS	Initialize(USBIT_KIND cNewKind = USBIT_KIND_BITCHARG, DWORD dwParam=0 ){//USBIT_KIND_BITCHARG,USBIT_KIND_BITCHARG_BOOST
		USBit_Destroy();
		status = ::USBit_Initialize(&hUSBit, cKind, dwParam ); 
		if(status== USBIT_STS_NOERROR)status=GetInfo();
		cKind=cNewKind;
		return status;
	};
	USBIT_STATUS	USBit_Destroy(DWORD dwParam=0  ){ 
		if(hUSBit==NULL) return status=USBIT_STS_NOTINIT;
		status= ::USBit_Destroy(hUSBit, dwParam  ); hUSBit=NULL; return status;
	};
public: // Constructor and Destructor
	USBitChargeDev(){wIO=(WORD)-1;hUSBit=NULL; cKind=USBIT_KIND_BITCHARG; ZeroMemory(&sInfo,sizeof(USBIT_INFO));};
	~USBitChargeDev(){USBit_Destroy();};
};
// gŃ`lNX̎E}``lRg[
// P`lT|[gȂꍇUSBitChargeDev݂̂ŃfoCX̎gpB
//
// Wp[ݒFՏ̃Wp[ɂăfoCXhCoFg
// ̃Wp[ɂĎۂ̃Rg[gύX킯ł͂Ȃ̂ŒӁB
// PɃfohɑ΂Fݒ̂߂ɑ݂
// CH[0] - 27MHz	- JP 5-6 / JP 7-8
// CH[1] - 35MHz	- JP 7-8
// CH[2] - 45MHz	- JP 5-6
// CH[3] - 57MHz	- JP 
//
#define USBITDEVMAX 4
class USBitControl {
public:
	USBitChargeDev *ch[USBITDEVMAX];	// gʃfoCX
	USBitChargeDev *first;				// ŏ̃foCX
private:
	USBitChargeDev device[USBITDEVMAX];
public: // Initialyzation
	void Init(void){
		int i;
		for(i=0;i<USBITDEVMAX;i++){
			device[i].Initialize();
			switch(device[i].GetFreq()){
				case 27: ch[0]=&device[i]; break;
				case 35: ch[1]=&device[i]; break;
				case 45: ch[2]=&device[i]; break;
				case 57: ch[3]=&device[i]; break;
			}
		}
		first = ch[0];
	}
public: // constructor / destructor
	USBitControl (){for(int i=0;i<USBITDEVMAX;i++)ch[i]=NULL;};
	~USBitControl (){};
};
